From 11aadf1a5064126f960dc64a88ceb3d94a5f3616 Mon Sep 17 00:00:00 2001
From: Sebastian Pop <spop@amazon.com>
Date: Fri, 25 Jun 2021 15:52:31 +0000
Subject: [PATCH] [arm64] port luma_vpp

luma_vpp[  4x4]		19.07x 	 27.30    	 520.77
luma_vpp[  8x8]		18.41x 	 110.21   	 2028.66
luma_vpp[16x16]		19.24x 	 423.61   	 8151.35
luma_vpp[32x32]		19.44x 	 1667.11  	 32409.84
luma_vpp[64x64]		19.51x 	 6623.75  	 129248.24
luma_vpp[  8x4]		18.13x 	 56.33    	 1021.32
luma_vpp[  4x8]		23.44x 	 43.89    	 1028.77
luma_vpp[ 16x8]		19.12x 	 213.02   	 4072.89
luma_vpp[ 8x16]		18.86x 	 215.77   	 4068.81
luma_vpp[32x16]		19.51x 	 831.52   	 16221.40
luma_vpp[16x32]		19.06x 	 854.80   	 16294.92
luma_vpp[64x32]		19.53x 	 3318.17  	 64811.30
luma_vpp[32x64]		19.47x 	 3321.06  	 64657.43
luma_vpp[16x12]		19.22x 	 318.55   	 6121.82
luma_vpp[12x16]		14.40x 	 424.52   	 6112.26
luma_vpp[ 16x4]		18.85x 	 108.40   	 2042.96
luma_vpp[ 4x16]		27.10x 	 76.03    	 2060.41
luma_vpp[32x24]		19.39x 	 1252.93  	 24296.47
luma_vpp[24x32]		19.62x 	 1236.63  	 24257.20
luma_vpp[ 32x8]		19.39x 	 418.19   	 8110.65
luma_vpp[ 8x32]		18.82x 	 430.45   	 8099.74
luma_vpp[64x48]		19.55x 	 4973.43  	 97229.91
luma_vpp[48x64]		19.41x 	 5008.33  	 97226.63
luma_vpp[64x16]		19.56x 	 1658.18  	 32435.13
luma_vpp[16x64]		17.21x 	 1891.74  	 32563.23
---
 source/common/aarch64/asm-primitives.cpp |  27 ++
 source/common/aarch64/asm.S              |  43 ++++
 source/common/aarch64/ipfilter8.S        | 307 +++++++++++++++++++++++
 source/common/aarch64/ipfilter8.h        |  26 ++
 source/common/arm/ipfilter8.S            |   2 +-
 5 files changed, 404 insertions(+), 1 deletion(-)

diff --git a/source/common/aarch64/asm-primitives.cpp b/source/common/aarch64/asm-primitives.cpp
index 592d183..902b44f 100644
--- a/source/common/aarch64/asm-primitives.cpp
+++ b/source/common/aarch64/asm-primitives.cpp
@@ -240,6 +240,33 @@ void setupAssemblyPrimitives(EncoderPrimitives &p, int cpuMask)
         p.pu[LUMA_64x32].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_64x32_neon);
         p.pu[LUMA_64x48].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_64x48_neon);
         p.pu[LUMA_64x64].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_64x64_neon);
+
+        // vertical interpolation filters
+        p.pu[LUMA_4x4].luma_vpp     = PFX(interp_8tap_vert_pp_4x4_neon);
+        p.pu[LUMA_4x8].luma_vpp     = PFX(interp_8tap_vert_pp_4x8_neon);
+        p.pu[LUMA_4x16].luma_vpp    = PFX(interp_8tap_vert_pp_4x16_neon);
+        p.pu[LUMA_8x4].luma_vpp     = PFX(interp_8tap_vert_pp_8x4_neon);
+        p.pu[LUMA_8x8].luma_vpp     = PFX(interp_8tap_vert_pp_8x8_neon);
+        p.pu[LUMA_8x16].luma_vpp    = PFX(interp_8tap_vert_pp_8x16_neon);
+        p.pu[LUMA_8x32].luma_vpp    = PFX(interp_8tap_vert_pp_8x32_neon);
+        p.pu[LUMA_16x4].luma_vpp    = PFX(interp_8tap_vert_pp_16x4_neon);
+        p.pu[LUMA_16x8].luma_vpp    = PFX(interp_8tap_vert_pp_16x8_neon);
+        p.pu[LUMA_16x16].luma_vpp   = PFX(interp_8tap_vert_pp_16x16_neon);
+        p.pu[LUMA_16x32].luma_vpp   = PFX(interp_8tap_vert_pp_16x32_neon);
+        p.pu[LUMA_16x64].luma_vpp   = PFX(interp_8tap_vert_pp_16x64_neon);
+        p.pu[LUMA_16x12].luma_vpp   = PFX(interp_8tap_vert_pp_16x12_neon);
+        p.pu[LUMA_32x8].luma_vpp    = PFX(interp_8tap_vert_pp_32x8_neon);
+        p.pu[LUMA_32x16].luma_vpp   = PFX(interp_8tap_vert_pp_32x16_neon);
+        p.pu[LUMA_32x32].luma_vpp   = PFX(interp_8tap_vert_pp_32x32_neon);
+        p.pu[LUMA_32x64].luma_vpp   = PFX(interp_8tap_vert_pp_32x64_neon);
+        p.pu[LUMA_32x24].luma_vpp   = PFX(interp_8tap_vert_pp_32x24_neon);
+        p.pu[LUMA_64x16].luma_vpp   = PFX(interp_8tap_vert_pp_64x16_neon);
+        p.pu[LUMA_64x32].luma_vpp   = PFX(interp_8tap_vert_pp_64x32_neon);
+        p.pu[LUMA_64x64].luma_vpp   = PFX(interp_8tap_vert_pp_64x64_neon);
+        p.pu[LUMA_64x48].luma_vpp   = PFX(interp_8tap_vert_pp_64x48_neon);
+        p.pu[LUMA_24x32].luma_vpp   = PFX(interp_8tap_vert_pp_24x32_neon);
+        p.pu[LUMA_48x64].luma_vpp   = PFX(interp_8tap_vert_pp_48x64_neon);
+        p.pu[LUMA_12x16].luma_vpp   = PFX(interp_8tap_vert_pp_12x16_neon);
     }
 }
 } // namespace X265_NS
diff --git a/source/common/aarch64/asm.S b/source/common/aarch64/asm.S
index 5f020a1..88f81da 100644
--- a/source/common/aarch64/asm.S
+++ b/source/common/aarch64/asm.S
@@ -35,6 +35,12 @@
 #define ELF @
 #endif
 
+#ifdef __MACH__
+#   define MACH
+#else
+#   define MACH #
+#endif
+
 #define HAVE_AS_FUNC 1
 
 #if HAVE_AS_FUNC
@@ -64,6 +70,43 @@ FUNC    .func   \name
 .endif
 .endm
 
+.macro  const   name, align=2
+    .macro endconst
+ELF     .size   \name, . - \name
+        .purgem endconst
+    .endm
+ELF     .section        .rodata
+MACH    .const_data
+        .align          \align
+\name:
+.endm
+
+.macro  movrel rd, val, offset=0
+#if defined(__APPLE__)
+  .if \offset < 0
+        adrp            \rd, \val@PAGE
+        add             \rd, \rd, \val@PAGEOFF
+        sub             \rd, \rd, -(\offset)
+  .else
+        adrp            \rd, \val+(\offset)@PAGE
+        add             \rd, \rd, \val+(\offset)@PAGEOFF
+  .endif
+#elif defined(PIC) && defined(_WIN32)
+  .if \offset < 0
+        adrp            \rd, \val
+        add             \rd, \rd, :lo12:\val
+        sub             \rd, \rd, -(\offset)
+  .else
+        adrp            \rd, \val+(\offset)
+        add             \rd, \rd, :lo12:\val+(\offset)
+  .endif
+#elif defined(PIC)
+        adrp            \rd, \val+(\offset)
+        add             \rd, \rd, :lo12:\val+(\offset)
+#else
+        ldr             \rd, =\val+\offset
+#endif
+.endm
 
 #define FENC_STRIDE 64
 #define FDEC_STRIDE 32
diff --git a/source/common/aarch64/ipfilter8.S b/source/common/aarch64/ipfilter8.S
index d467952..820bdd1 100644
--- a/source/common/aarch64/ipfilter8.S
+++ b/source/common/aarch64/ipfilter8.S
@@ -240,6 +240,101 @@ function x265_filterPixelToShort_48x64_neon
     ret
 endfunc
 
+//**************luma_vpp************
+
+.macro LUMA_VPP_4xN h
+function x265_interp_8tap_vert_pp_4x\h\()_neon
+    movrel          x10, g_luma_s16
+    sub             x0, x0, x1
+    sub             x0, x0, x1, lsl #1         // src -= 3 * srcStride
+    lsl             x4, x4, #4
+    ldr             q0, [x10, x4]              // q0 = luma interpolate coeff
+    dup             v24.8h, v0.h[0]
+    dup             v25.8h, v0.h[1]
+    trn1            v24.2d, v24.2d, v25.2d
+    dup             v26.8h, v0.h[2]
+    dup             v27.8h, v0.h[3]
+    trn1            v26.2d, v26.2d, v27.2d
+    dup             v28.8h, v0.h[4]
+    dup             v29.8h, v0.h[5]
+    trn1            v28.2d, v28.2d, v29.2d
+    dup             v30.8h, v0.h[6]
+    dup             v31.8h, v0.h[7]
+    trn1            v30.2d, v30.2d, v31.2d
+
+    // prepare to load 8 lines
+    ld1             {v0.s}[0], [x0], x1
+    ld1             {v0.s}[1], [x0], x1
+    ushll           v0.8h, v0.8b, #0
+    ld1             {v1.s}[0], [x0], x1
+    ld1             {v1.s}[1], [x0], x1
+    ushll           v1.8h, v1.8b, #0
+    ld1             {v2.s}[0], [x0], x1
+    ld1             {v2.s}[1], [x0], x1
+    ushll           v2.8h, v2.8b, #0
+    ld1             {v3.s}[0], [x0], x1
+    ld1             {v3.s}[1], [x0], x1
+    ushll           v3.8h, v3.8b, #0
+
+    mov             x9, #\h
+.loop_4x\h:
+    ld1             {v4.s}[0], [x0], x1
+    ld1             {v4.s}[1], [x0], x1
+    ushll           v4.8h, v4.8b, #0
+
+    // row[0-1]
+    mul             v16.8h, v0.8h, v24.8h
+    ext             v21.16b, v0.16b, v1.16b, #8
+    mul             v17.8h, v21.8h, v24.8h
+    mov             v0.16b, v1.16b
+
+    // row[2-3]
+    mla             v16.8h, v1.8h, v26.8h
+    ext             v21.16b, v1.16b, v2.16b, #8
+    mla             v17.8h, v21.8h, v26.8h
+    mov             v1.16b, v2.16b
+
+    // row[4-5]
+    mla             v16.8h, v2.8h, v28.8h
+    ext             v21.16b, v2.16b, v3.16b, #8
+    mla             v17.8h, v21.8h, v28.8h
+    mov             v2.16b, v3.16b
+
+    // row[6-7]
+    mla             v16.8h, v3.8h, v30.8h
+    ext             v21.16b, v3.16b, v4.16b, #8
+    mla             v17.8h, v21.8h, v30.8h
+    mov             v3.16b, v4.16b
+
+    // sum row[0-7]
+    trn1            v20.2d, v16.2d, v17.2d
+    trn2            v21.2d, v16.2d, v17.2d
+    add             v16.8h, v20.8h, v21.8h
+
+    sqrshrun        v16.8b,  v16.8h,  #6
+    st1             {v16.s}[0], [x2], x3
+    st1             {v16.s}[1], [x2], x3
+
+    sub             x9, x9, #2
+    cbnz            x9, .loop_4x\h
+    ret
+endfunc
+.endm
+
+LUMA_VPP_4xN 4
+LUMA_VPP_4xN 8
+LUMA_VPP_4xN 16
+
+        // d0 -> v0
+        // d1 -> v4
+        // d2 -> v1
+        // d3 -> v5
+        // d4 -> v2
+        // d5 -> v6
+        // d6 -> v3
+        // d7 -> v7
+        // temp regs: v16, v19, v20, v21, v22, v23, v24.
+        // result in v17.4s, v18.4s
 .macro qpel_filter_0_32b
     movi            v24.8h, #64
     uxtl            v19.8h, v5.8b
@@ -376,8 +471,213 @@ endfunc
     add             v18.4s, v18.4s, v22.4s
 .endm
 
+.macro FILTER_VPP a b filterv
+
+.loop_\filterv\()_\a\()x\b:
+
+    mov             x7, x2
+    mov             x6, x0
+    eor             x9, x9, x9
+
+.loop_w8_\filterv\()_\a\()x\b:
+
+    add             x6, x0, x9
+
+    ld1             {v0.8b}, [x6], x1
+    ld1             {v4.8b}, [x6], x1
+    ld1             {v1.8b}, [x6], x1
+    ld1             {v5.8b}, [x6], x1
+    ld1             {v2.8b}, [x6], x1
+    ld1             {v6.8b}, [x6], x1
+    ld1             {v3.8b}, [x6], x1
+    ld1             {v7.8b}, [x6], x1
+
+    eor             v17.16b, v17.16b, v17.16b
+    eor             v18.16b, v18.16b, v18.16b
+
+   \filterv
+
+    mov             w12, #32
+    dup             v16.4s, w12
+    add             v17.4s, v17.4s, v16.4s
+    sqshrun         v0.8b, v17.8h, #6
+    add             v18.4s, v18.4s, v16.4s
+    sqshrun         v1.8b, v18.8h, #6
+    trn1            v0.2d, v0.2d, v1.2d
+    sqxtun          v0.8b, v0.8h
+    st1             {v0.8b}, [x7], #8
+
+    add             x9, x9, #8
+    cmp             x9, #\a
+    blt             .loop_w8_\filterv\()_\a\()x\b
+
+    add             x0, x0, x1
+    add             x2, x2, x3
+    sub             x5, x5, #1
+    cbnz            x5, .loop_\filterv\()_\a\()x\b
+
+.endm
+
+// void interp_vert_pp_c(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx)
+.macro LUMA_VPP  w h
+function x265_interp_8tap_vert_pp_\w\()x\h\()_neon
+
+    lsl             x5, x1, #2
+    sub             x5, x5, x1
+    sub             x0, x0, x5      // src -= (8 / 2 - 1) * srcStride
+    mov             x5, #\h
+
+    cmp             x4, #0
+    b.eq            0f
+    cmp             x4, #1
+    b.eq            1f
+    cmp             x4, #2
+    b.eq            2f
+    cmp             x4, #3
+    b.eq            3f
+0:
+    FILTER_VPP  \w \h qpel_filter_0_32b
+    ret
+1:
+    FILTER_VPP  \w \h qpel_filter_1_32b
+    ret
+2:
+    FILTER_VPP  \w \h qpel_filter_2_32b
+    ret
+3:
+    FILTER_VPP  \w \h qpel_filter_3_32b
+    ret
+endfunc
+.endm
 
+LUMA_VPP 8 4
+LUMA_VPP 8 8
+LUMA_VPP 8 16
+LUMA_VPP 8 32
+LUMA_VPP 16 4
+LUMA_VPP 16 8
+LUMA_VPP 16 16
+LUMA_VPP 16 32
+LUMA_VPP 16 64
+LUMA_VPP 16 12
+LUMA_VPP 32 8
+LUMA_VPP 32 16
+LUMA_VPP 32 32
+LUMA_VPP 32 64
+LUMA_VPP 32 24
+LUMA_VPP 64 16
+LUMA_VPP 64 32
+LUMA_VPP 64 64
+LUMA_VPP 64 48
+LUMA_VPP 24 32
+LUMA_VPP 48 64
+
+function x265_interp_8tap_vert_pp_12x16_neon
+    lsl             x5, x1, #2
+    sub             x5, x5, x1
+    sub             x0, x0, x5      // src -= (8 / 2 - 1) * srcStride
+
+    mov             x5, #16
+.loop_vpp_12x16:
+
+    mov             x6, x0
+    mov             x7, x2
+
+    ld1             {v0.8b}, [x6], x1
+    ld1             {v4.8b}, [x6], x1
+    ld1             {v1.8b}, [x6], x1
+    ld1             {v5.8b}, [x6], x1
+    ld1             {v2.8b}, [x6], x1
+    ld1             {v6.8b}, [x6], x1
+    ld1             {v3.8b}, [x6], x1
+    ld1             {v7.8b}, [x6], x1
+
+    eor             v17.16b, v17.16b, v17.16b
+    eor             v18.16b, v18.16b, v18.16b
+
+    cmp             x4, #0
+    b.eq            0f
+    cmp             x4, #1
+    b.eq            1f
+    cmp             x4, #2
+    b.eq            2f
+    cmp             x4, #3
+    b.eq            3f
+0:
+    qpel_filter_0_32b
+    b            5f
+1:
+    qpel_filter_1_32b
+    b            5f
+2:
+    qpel_filter_2_32b
+    b            5f
+3:
+    qpel_filter_3_32b
+    b            5f
+5:
+    mov             w12, #32
+    dup             v16.4s, w12
+    add             v17.4s, v17.4s, v16.4s
+    sqshrun         v0.8b, v17.8h, #6
+    add             v18.4s, v18.4s, v16.4s
+    sqshrun         v1.8b, v18.8h, #6
+    trn1            v0.2d, v0.2d, v1.2d
+    sqxtun          v0.8b, v0.8h
+    st1             {v0.8b}, [x7], #8
+
+    add             x6, x0, #8
+
+    ld1             {v0.8b}, [x6], x1
+    ld1             {v4.8b}, [x6], x1
+    ld1             {v1.8b}, [x6], x1
+    ld1             {v5.8b}, [x6], x1
+    ld1             {v2.8b}, [x6], x1
+    ld1             {v6.8b}, [x6], x1
+    ld1             {v3.8b}, [x6], x1
+    ld1             {v7.8b}, [x6], x1
+
+    eor             v17.16b, v17.16b, v17.16b
+    eor             v18.16b, v18.16b, v18.16b
+
+    cmp             x4, #0
+    b.eq            0f
+    cmp             x4, #1
+    b.eq            1f
+    cmp             x4, #2
+    b.eq            2f
+    cmp             x4, #3
+    b.eq            3f
+0:
+    qpel_filter_0_32b
+    b            5f
+1:
+    qpel_filter_1_32b
+    b            5f
+2:
+    qpel_filter_2_32b
+    b            5f
+3:
+    qpel_filter_3_32b
+    b            5f
+5:
+    mov             w12, #32
+    dup             v16.4s, w12
+    add             v17.4s, v17.4s, v16.4s
+    sqshrun         v0.8b, v17.8h, #6
+    add             v18.4s, v18.4s, v16.4s
+    sqshrun         v1.8b, v18.8h, #6
+    trn1            v0.2d, v0.2d, v1.2d
+    sqxtun          v0.8b, v0.8h
+    fmov            w6, s0
+    str             w6, [x7], #4
 
+    add             x0, x0, x1
+    add             x2, x2, x3
+    sub             x5, x5, #1
+    cbnz            x5, .loop_vpp_12x16
+    ret
+endfunc
 
 .macro vextin8
     ld1             {v3.16b}, [x11], #16
@@ -621,3 +921,10 @@ LUMA_HPS    64 16
 LUMA_HPS    64 32
 LUMA_HPS    64 48
 LUMA_HPS    64 64
+
+const g_luma_s16, align=8
+.hword   0, 0,   0, 64,  0,   0, 0,  0
+.hword  -1, 4, -10, 58, 17,  -5, 1,  0
+.hword  -1, 4, -11, 40, 40, -11, 4, -1
+.hword   0, 1,  -5, 17, 58, -10, 4, -1
+endconst
diff --git a/source/common/aarch64/ipfilter8.h b/source/common/aarch64/ipfilter8.h
index 2bc81bd..fd724aa 100644
--- a/source/common/aarch64/ipfilter8.h
+++ b/source/common/aarch64/ipfilter8.h
@@ -50,6 +50,32 @@ void x265_filterPixelToShort_64x32_neon(const pixel* src, intptr_t srcStride, in
 void x265_filterPixelToShort_64x48_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
 void x265_filterPixelToShort_64x64_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
 
+void x265_interp_8tap_vert_pp_4x4_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_4x8_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_4x16_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_8x4_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_8x8_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_8x16_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_8x32_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_16x4_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_16x8_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_16x16_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_16x32_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_16x64_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_16x12_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_32x8_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_32x16_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_32x32_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_32x64_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_32x24_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_64x16_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_64x32_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_64x64_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_64x48_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_24x32_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_48x64_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_12x16_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+
 void x265_interp_8tap_horiz_ps_4x4_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
 void x265_interp_8tap_horiz_ps_4x8_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
 void x265_interp_8tap_horiz_ps_4x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
diff --git a/source/common/arm/ipfilter8.S b/source/common/arm/ipfilter8.S
index 8b7f5b3..c6ac166 100644
--- a/source/common/arm/ipfilter8.S
+++ b/source/common/arm/ipfilter8.S
@@ -795,7 +795,7 @@ function x265_interp_8tap_vert_pp_4x\h\()_neon
     vst1.u32    {d18[1]}, [r2], r3
 
     subs        r12, #2
-    bne        .loop_4x4
+    bne        .loop_4x\h
 
     pop         {pc}
     .ltorg
-- 
2.25.1

